#!/bin/bash

# assume this script in this directory
export JPORT_HOME="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
arguments="$@"

if which java >/dev/null; then
    _java=java
elif [[ -n "$JAVA_HOME" ]] && [[ -x "$JAVA_HOME/bin/java" ]];  then
    _java="$JAVA_HOME/bin/java"
else
    echo "No java detected! Please install it from https://java.com/download"; exit 0
fi

if [[ "$_java" ]]; then
    version=$("$_java" -version 2>&1 | awk -F '"' '/version/ {print $2}')
    if [[ "$version" < "1.7" ]]; then
        echo "Java version is less than 1.7. Please update it."; exit 0;
    fi
fi


export JPORTLIB=$JPORT_HOME/jport.jar
CLASSPATH=$JPORTLIB:$CLASSPATH
$_java -cp "$CLASSPATH" -Djport.home="$JPORT_HOME"  com.jport.JPort
