function q=conv(p1,p2)
%% usage: q=conv(p1,p2)
%% 
%% If p1, p2 are polynomial coefficients,
%% q is the coefficient vector of the product.
%% <pre>Example:
%% >> p1=[1 1];p2=[1 -1];
%% >> conv(p1,p2)
%% q = 
%%  1   0   -1 </pre>

	len1=length(p1);
	len2=length(p2);
	q=zeros(1,len1+len2-1);
	
	for i=1:len1
		for k=1:len2
			q(k+i-1) += p1(i)*p2(k);
		end
	end
end